commit 4b03d2a767a4797f3736f20d3f6f50baecd12ea9
Author: Vojtěch Bartička <aitakaitov@gmail.com>
Date:   Fri May 20 06:42:55 2022 +0200

    More comments in backend

diff --git a/Backend/Models/Annotations/AnnotationGetRequest.cs b/Backend/Models/Annotations/AnnotationGetRequest.cs
deleted file mode 100644
index 53dd0eb..0000000
--- a/Backend/Models/Annotations/AnnotationGetRequest.cs
+++ /dev/null
@@ -1,13 +0,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-
-namespace Models.Annotations
-{
-    public class AnnotationGetRequest
-    {
-        public Guid AnnotationId { get; set; }
-    }
-}
diff --git a/Backend/Models/Annotations/AnnotationInfo.cs b/Backend/Models/Annotations/AnnotationInfo.cs
index cce5eb6..271a2f6 100644
--- a/Backend/Models/Annotations/AnnotationInfo.cs
+++ b/Backend/Models/Annotations/AnnotationInfo.cs
@@ -17,7 +17,13 @@ namespace Models.Annotations
         public EState State { get; set; }
         public EDocumentType Type { get; set; }
         public string Note { get; set; }
+        /// <summary>
+        /// List of tags essentially
+        /// </summary>
         public List<TagInstanceInfo> TagInstances { get; set; } = new();
+        /// <summary>
+        /// CSS for rendering
+        /// </summary>
         public List<TagInstanceCSSInfo> CSSInfo { get; set; } = new();
     }
 }
diff --git a/Backend/Models/Annotations/AnnotationListInfo.cs b/Backend/Models/Annotations/AnnotationListInfo.cs
index cfdc28d..e9274d5 100644
--- a/Backend/Models/Annotations/AnnotationListInfo.cs
+++ b/Backend/Models/Annotations/AnnotationListInfo.cs
@@ -9,8 +9,17 @@ namespace Models.Annotations
 {
     public class AnnotationListInfo
     {
+        /// <summary>
+        /// What document
+        /// </summary>
         public string DocumentName { get; set; }
+        /// <summary>
+        /// In what state
+        /// </summary>
         public EState State { get; set; }
+        /// <summary>
+        /// The annotation
+        /// </summary>
         public Guid AnnotationId { get; set; }
     }
 }
diff --git a/Backend/Models/Annotations/AnnotationsAddRequest.cs b/Backend/Models/Annotations/AnnotationsAddRequest.cs
index febbb6f..0bacaaa 100644
--- a/Backend/Models/Annotations/AnnotationsAddRequest.cs
+++ b/Backend/Models/Annotations/AnnotationsAddRequest.cs
@@ -8,7 +8,13 @@ namespace Models.Annotations;
 
 public class AnnotationsAddRequest
 {
+    /// <summary>
+    /// List of users to assigned the documents
+    /// </summary>
     public List<Guid> UserIdList { get; set; }
+    /// <summary>
+    /// List of documents to assign the users
+    /// </summary>
     public List<Guid> DocumentIdList { get; set; }
 }
 
diff --git a/Backend/Models/Documents/DocumentAddInfo.cs b/Backend/Models/Documents/DocumentAddInfo.cs
index 7df8a76..9397e6d 100644
--- a/Backend/Models/Documents/DocumentAddInfo.cs
+++ b/Backend/Models/Documents/DocumentAddInfo.cs
@@ -9,12 +9,17 @@ namespace Models.Documents;
 
 # nullable disable
 /**
- * If the file is plaintext, we except it to be a single document
+ * If the file is plaintext, we except it to be a single document base64 encoded
  * If the file is base64, we expect it to be a ZIP file with plaintext documents in its root
  */
 public class DocumentAddInfo
 {
     public string Name { get; set; }
+
+    /// <summary>
+    /// The backend relies on this being correct
+    /// </summary>
     public EAddDocumentFormat Format { get; set; } = EAddDocumentFormat.TEXTFILE;
+
     public string Content { get; set; }
 }
diff --git a/Backend/Models/Tags/TagInstanceInfo.cs b/Backend/Models/Tags/TagInstanceInfo.cs
index 410fb5a..c1cf5a7 100644
--- a/Backend/Models/Tags/TagInstanceInfo.cs
+++ b/Backend/Models/Tags/TagInstanceInfo.cs
@@ -10,15 +10,32 @@ namespace Models.Tags
 {
     public class TagInstanceInfo
     {
-        /** For database */
+        /// <summary>
+        /// unique ID
+        /// </summary>
         public Guid OccurenceId { get; set; }
         public string TagName { get; set; }
+
+        /// <summary>
+        /// ID of the Tag in database
+        /// </summary>
         public Guid TagId { get; set; }
         public string TagCategoryName { get; set; }
+
+        /// <summary>
+        /// ID of the category in database
+        /// </summary>
         public Guid TagCategoryId { get; set; }
         public string? SubTagName { get; set; }
+
+        /// <summary>
+        /// ID of the subtag in database
+        /// </summary>
         public Guid? SubTagId { get; set; }
 
+        /// <summary>
+        /// Instance of the tag (multipart tags share the same instance)
+        /// </summary>
         public Guid Instance { get; set; }
         public int Position { get; set; }
         public int Length { get; set; }
@@ -28,7 +45,13 @@ namespace Models.Tags
         public ETagSentiment? Sentiment { get; set; }
         public string SelectedText { get; set; }
 
+        /// <summary>
+        /// Optional list of users who have agreed on this tag - only when the annotation is final
+        /// </summary>
         public List<UserInfo>? Users { get; set; }
+        /// <summary>
+        /// Optional information about the tag being resolved - only when the annotation is final
+        /// </summary>
         public bool? IsFinal { get; set; }
     }
 }
diff --git a/Backend/Models/Users/DocumentUserInfo.cs b/Backend/Models/Users/DocumentUserInfo.cs
index 2e08e23..e44274a 100644
--- a/Backend/Models/Users/DocumentUserInfo.cs
+++ b/Backend/Models/Users/DocumentUserInfo.cs
@@ -9,11 +9,21 @@ namespace Models.Users
 {
     public class DocumentUserInfo
     {
+        /// <summary>
+        /// User Id
+        /// </summary>
         public Guid Id { get; set; }
         public string Username { get; set; }
         public string Name { get; set; }
         public string Surname { get; set; }
+
+        /// <summary>
+        /// State of the annotation
+        /// </summary>
         public EState State { get; set; }
+        /// <summary>
+        /// Id of the annotation
+        /// </summary>
         public Guid AnnotationId { get; set; }
     }
 }